import java.util.Enumeration;
import xyzzy.hardware.UsbIo;


/** Show the banner.  This application class is intended to be a main
    class of usbio.jar file to supply users who executed the .jar
    file as a standalone application.  */
class Banner
{
    public static void main ( final String[] argv )
    {
	try {
	    System.out.println( "USBIO Support Program" );

	    final Enumeration enum = UsbIo.allDevices();
	    int n = 0;
	    while ( enum.hasMoreElements() ) {
		final UsbIo.Device usbio = ( UsbIo.Device )enum.nextElement();
		/* usbio device object must be closed after _use_.  */
		usbio.close();
		n++;
	    }
	    System.out.println( n + " USBIO devices are found." );
	} catch ( Throwable e ) {
	    e.printStackTrace();
	}
    }
}
