/*
USBIO Support Program
Copyright (C) 2001 by Masahiro Sekiguchi, all rights reserved.

Redistribution and use in source and/or binary forms, with or without
modification, are permitted provided that the following conditions are
met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote
   products derived from this software.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
*/

package xyzzy.hardware.jdirect;

/** The class HID is a wrapper around Win32 APIs defined in HID.DLL.  */
/** @dll.import("HID",auto) */
final class Hid {

    public native static boolean HidD_GetAttributes (
	int /*HANDLE*/ hidDeviceObject,
	HIDD_ATTRIBUTES attributes );

    public native static void HidD_GetHidGuid (
	byte[/*16*/] /*PGUID*/ hidGuid );

    public native static boolean HidD_GetPreparsedData (
	int /*HANDLE*/ hidDeviceObject,
	int[/*1*/] /*(PHIDP_PREPARSED_DATA *)*/ ppreparsedData );

    public native static boolean HidD_FreePreparsedData (
	int /*PHIDP_PREPARSED_DATA*/ preparsedData );

    public native static boolean HidD_FlushQueue (
	int /*HANDLE*/ hidDeviceObject );

//  public native static boolean HidD_GetConfiguration (
//	int /*HANDLE*/ hidDeviceObject,
//	HIDD_CONFIGURATION /*PHIDD_CONFIGURATION*/ configuration,
//	int /*ULONG*/ configurationLength /* == 12 */ );

//  public native static boolean HidD_SetConfiguration (
//	int /*HANDLE*/ hidDeviceObject,
//	HIDD_CONFIGURATION configuration,
//	int /*ULONG*/ configurationLength /* == 12 */ );

    public native static boolean HidD_GetFeature (
	int /*HANDLE*/ hidDeviceObject,
	byte[] /*PVOID*/ reportBuffer,
	int /*ULONG*/ reportBufferLength );

    public native static boolean HidD_SetFeature (
	int /*HANDLE*/ hidDeviceObject,
	byte[] /*PVOID*/ reportBuffer,
	int /*ULONG*/ reportBufferLength );

    public native static boolean HidD_GetNumInputBuffers (
	int /*HANDLE*/ hidDeviceObject,
	int[] /*PULONG*/ numberBuffers );

    public native static boolean HidD_SetNumInputBuffers (
	int /*HANDLE*/ hidDeviceObject,
	int /*ULONG*/ numberBuffers );

    public native static boolean HidD_GetPhysicalDescriptor (
	int /*HANDLE*/ hidDeviceObject,
	byte[] /*PVOID*/ buffer,
	int /*ULONG*/ bufferLength );

    public native static boolean HidD_GetManufacturerString (
	int /*HANDLE*/ hidDeviceObject,
	byte[] /*PVOID*/ buffer,
	int /*ULONG*/ bufferLength );

    public native static boolean HidD_GetProductString (
	int /*HANDLE*/ hidDeviceObject,
	byte[] /*PVOID*/ buffer,
	int /*ULONG*/ bufferLength );

    public native static boolean HidD_GetIndexedString (
	int /*HANDLE*/ hidDeviceObject,
	int /*ULONG*/ stringIndex,
	byte[] /*PVOID*/ buffer,
	int /*ULONG*/ bufferLength );

    public native static boolean HidD_GetSerialNumberString (
	int /*HANDLE*/ hidDeviceObject,
	byte[] /*PVOID*/ buffer,
	int /*ULONG*/ bufferLength );
}



