/*
USBIO Support Program
Copyright (C) 2001 by Masahiro Sekiguchi, all rights reserved.

Redistribution and use in source and/or binary forms, with or without
modification, are permitted provided that the following conditions are
met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote
   products derived from this software.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
*/

package xyzzy.hardware.jdirect;

/** @dll.import("SETUPAPI",auto) */
final class SetupApi
{
    public native static int /*HDEVINFO*/ SetupDiCreateDeviceInfoList (
	GUID classGuid,
	int /*HWND*/ hwndParent );

    public native static int /*HDEVINFO*/ SetupDiCreateDeviceInfoListEx (
	GUID classGuid,
	int /*HWND*/ hwndParent,
	String /*PCSTR*/ macineName,
	int /*PVOID*/ reserved );

    public native static boolean SetupDiGetDeviceInfoListClass (
	int /*HDEVINFO*/ deviceInfoSet,
	GUID classGuid );

//  public native static boolean SetupDiGetDeviceInfoListDetail (
//	int /*HDEVINFO*/ deviceInfoSet,
//	SP_DEVINFO_LIST_DETAIL_DATA deviceInfoSetDetailData );

    public native static int SetupDiDestroyDeviceInfoList (
	int /*HDEVINFO*/ deviceInfoSet );

    public native static boolean SetupDiEnumDeviceInterfaces (
	int /*HDEVINFO*/ deviceInfoSet,
	SP_DEVINFO_DATA deviceInfoData,
	byte[] /*(GUID CONST *)*/ interfaceClassGuid,
	int /*DWORD*/ memberIndex,
	SP_DEVICE_INTERFACE_DATA deviceInterfaceData );

    public native static int /*HDEVINFO*/ SetupDiGetClassDevs (
	byte[] /*(GUID CONST *)*/ classGuid,
	String /*PCSTR/PCWSTR*/ enumerator,
	int /*HWND*/ hwndParent,
	int /*DWORD*/ flags );

    public static final int DIGCF_DEFAULT = 0x00000001;
    public static final int DIGCF_PRESENT = 0x00000002;
    public static final int DIGCF_ALLCLASSES = 0x00000004;
    public static final int DIGCF_PROFILE = 0x00000008;
    public static final int DIGCF_DEVICEINTERFACE = 0x00000010;

    public native static boolean SetupDiGetDeviceInterfaceDetail (
	int /*HDEVINFO*/ deviceInfoSet,
	SP_DEVICE_INTERFACE_DATA deviceInterfaceData,
	SP_DEVICE_INTERFACE_DETAIL_DATA deviceInterfaceDetailData,
	int /*DWORD*/ deviceInterfaceDetailDataSize,
	int[] /*PDWORD*/ requiredSize,
	SP_DEVINFO_DATA deviceInfoData );
}
